Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | ENUM CONSTANTS | FIELD | METHOD | DETAIL: ENUM CONSTANTS | FIELD | METHOD

## java.util.concurrent
Enum TimeUnit

    java.lang.Object
      java.lang.Enum<TimeUnit>
          java.util.concurrent.TimeUnit

All Implemented Interfaces:
  Serializable, Comparable<TimeUnit>

    public enum TimeUnit

extends Enum<TimeUnit>

A `TimeUnit` represents time durations at a given unit of granularity and provides utility methods to convert across units, and to perform timing and delay operations in these units. A `TimeUnit` does not maintain time information, but only helps organize and use time representations that may be maintained separately across various contexts.

A `TimeUnit` is mainly used to inform time-based methods how a given timing parameter should be interpreted. For example, the following code will timeout in 50 milliseconds if the `lock` is not available:

      Lock lock = ...;
      if ( lock.tryLock(50L, TimeUnit.MILLISECONDS) ) ...

while this code will timeout in 50 seconds:

      Lock lock = ...;
      if ( lock.tryLock(50L, TimeUnit.SECONDS) ) ...

Note however, that there is no guarantee that a particular timeout implementation will be able to notice the passage of time at the same granularity as the given `TimeUnit`.

Since:
  1.5

Enum Constant Summary
`MICROSECONDS`
`MILLISECONDS`
`NANOSECONDS`
`SECONDS`

Method Summary
`long` | `convert(long duration, TimeUnit unit)` Convert the given time duration in the given unit to this unit.
`void` | `sleep(long timeout)` Perform a `Thread.sleep` using this unit.
`void` | `timedJoin(Thread thread, long timeout)` Perform a timed `Thread.join` using this time unit.
`void` | `timedWait(Object obj, long timeout)` Perform a timed `Object.wait` using this time unit.
`long` | `toMicros(long duration)` Equivalent to `MICROSECONDS.convert(duration, this)`.
`long` | `toMillis(long duration)` Equivalent to `MILLISECONDS.convert(duration, this)`.
`long` | `toNanos(long duration)` Equivalent to `NANOSECONDS.convert(duration, this)`.
`long` | `toSeconds(long duration)` Equivalent to `SECONDS.convert(duration, this)`.
`static TimeUnit` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static TimeUnit[]` | `values()` Returns an array containing the constants of this enum type, in the order they're declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### NANOSECONDS

    public static final TimeUnit NANOSECONDS

### MICROSECONDS

    public static final TimeUnit MICROSECONDS

### MILLISECONDS

    public static final TimeUnit MILLISECONDS

### SECONDS

    public static final TimeUnit SECONDS

Method Detail

### values

    public static final TimeUnit[] values()

  Returns an array containing the constants of this enum type, in the order they're declared. This method may be used to iterate over the constants as follows:

      for(TimeUnit c : TimeUnit.values())
              System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they're declared

### valueOf

    public static TimeUnit valueOf(String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `IllegalArgumentException` - if this enum type has no constant with the specified name

### convert

    public long convert(long duration,
                        TimeUnit unit)

  Convert the given time duration in the given unit to this unit. Conversions from finer to coarser granularities truncate, so lose precision. For example converting `999` milliseconds to seconds results in `0`. Conversions from coarser to finer granularities with arguments that would numerically overflow saturate to `Long.MIN_VALUE` if negative or `Long.MAX_VALUE` if positive.

  Parameters:
    `duration` - the time duration in the given `unit`
    `unit` - the unit of the `duration` argument
  Returns:
    the converted duration in this unit, or `Long.MIN_VALUE` if conversion would negatively overflow, or `Long.MAX_VALUE` if it would positively overflow.

### toNanos

    public long toNanos(long duration)

  Equivalent to `NANOSECONDS.convert(duration, this)`.

  Parameters:
    `duration` - the duration
  Returns:
    the converted duration, or `Long.MIN_VALUE` if conversion would negatively overflow, or `Long.MAX_VALUE` if it would positively overflow.
  See Also:
    `convert(long, java.util.concurrent.TimeUnit)`

### toMicros

    public long toMicros(long duration)

  Equivalent to `MICROSECONDS.convert(duration, this)`.

  Parameters:
    `duration` - the duration
  Returns:
    the converted duration, or `Long.MIN_VALUE` if conversion would negatively overflow, or `Long.MAX_VALUE` if it would positively overflow.
  See Also:
    `convert(long, java.util.concurrent.TimeUnit)`

### toMillis

    public long toMillis(long duration)

  Equivalent to `MILLISECONDS.convert(duration, this)`.

  Parameters:
    `duration` - the duration
  Returns:
    the converted duration, or `Long.MIN_VALUE` if conversion would negatively overflow, or `Long.MAX_VALUE` if it would positively overflow.
  See Also:
    `convert(long, java.util.concurrent.TimeUnit)`

### toSeconds

    public long toSeconds(long duration)

  Equivalent to `SECONDS.convert(duration, this)`.

  Parameters:
    `duration` - the duration
  Returns:
    the converted duration.
  See Also:
    `convert(long, java.util.concurrent.TimeUnit)`

### timedWait

    public void timedWait(Object obj,
                          long timeout)
                   throws InterruptedException

  Perform a timed `Object.wait` using this time unit. This is a convenience method that converts timeout arguments into the form required by the `Object.wait` method.

  For example, you could implement a blocking `poll` method (see `BlockingQueue.poll`) using:

        public synchronized  Object poll(long timeout, TimeUnit unit) throws InterruptedException {
          while (empty) {
            unit.timedWait(this, timeout);
            ...
          }
        }

  Parameters:
    `obj` - the object to wait on
    `timeout` - the maximum time to wait.
  Throws:
    `InterruptedException` - if interrupted while waiting.
  See Also:
    `Object.wait(long, int)`

### timedJoin

    public void timedJoin(Thread thread,
                          long timeout)
                   throws InterruptedException

  Perform a timed `Thread.join` using this time unit. This is a convenience method that converts time arguments into the form required by the `Thread.join` method.

  Parameters:
    `thread` - the thread to wait for
    `timeout` - the maximum time to wait
  Throws:
    `InterruptedException` - if interrupted while waiting.
  See Also:
    `Thread.join(long, int)`

### sleep

    public void sleep(long timeout)
               throws InterruptedException

  Perform a `Thread.sleep` using this unit. This is a convenience method that converts time arguments into the form required by the `Thread.sleep` method.

  Parameters:
    `timeout` - the minimum time to sleep
  Throws:
    `InterruptedException` - if interrupted while sleeping.
  See Also:
    `Thread.sleep(long)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | ENUM CONSTANTS | FIELD | METHOD | DETAIL: ENUM CONSTANTS | FIELD | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.